/*
 *  Pythoong 
 * (C) 2000 christophe cressend
 *
 * 
 */

#include <glib.h>

#include "pythoong_def.h"
#include "maze.h"

gboolean PytMaze_init(gint level,Maze * Maze)
{ 
     gint i,j;
     gint up,down,left,right;
     gulong value,resul;
     gchar* file=NULL;
     if (level == Maze->level) return TRUE;
     file=Pyt_Prefs_get_level_file(level);
     Maze->level=level;
     if (FALSE == PytGraphics_load_maze_image(file))
     {
	  return FALSE;
     }

     Maze->rem_pills=0;

     for (j=0;j<GAME_SIZE_TILE_X;j++)
     { 
	  for (i=0;i<GAME_SIZE_TILE_Y;i++)
	  { 
	       value=PytGraphics_get_maze(i,j); 
               Maze->walls[i][j]=(value >0);
	       Maze->pills[i][j]=((Maze->walls[i][j]==0) & ((i+j)%2==0));
	       Maze->rem_pills+=Maze->pills[i][j];
	  }
     }
     for (j=0;j<GAME_SIZE_TILE_X;j++)
     {
	  for (i=0;i<GAME_SIZE_TILE_Y;i++)
	  {
	       if(Maze->walls[i][j]==0)
	       {
		    Maze->walls[i][j]=16;
	       }
               else
	       {     
		    if (j==0) up=0; else up=(Maze->walls[i][j-1]%16>0?1:0);
		    if (j==GAME_SIZE_TILE_X-1) down=0; else down=(Maze->walls[i][j+1]%16>0?1:0);
		    if (i==0) left=0; else left=(Maze->walls[i-1][j]%16>0?1:0);
		    if (i==GAME_SIZE_TILE_Y-1) right=0; else right=(Maze->walls[i+1][j]%16>0?1:0);
		    resul=((up)+(left*2)+(down*4)+(right*8));
		    Maze->walls[i][j]=(int)resul;
	       }
	       
	  }
     }
     return TRUE;     
}  

gboolean PytMaze_is_walls(Maze* Maze,gint x,gint y)
{
     if (Maze->walls[x][y]!=16) 
     {
	  return TRUE;
     }
     else
     {
	  return FALSE;
     }
}
gboolean PytMaze_is_pill(Maze* Maze,gint x,gint y)
{
     if (0 < Maze->pills[x][y])
     {
	  return TRUE;
     }
     else
     {
	  return FALSE;
     }
}

gboolean PytMaze_eat_pill(Maze* maze,gint x, gint y)
{
     if (0 < maze->pills[x][y])
     {
	  maze->pills[x][y]=0;
          maze->rem_pills=maze->rem_pills-1;
          return TRUE;
     }
     else return FALSE;
}
void PytMaze_draw_maze(Maze* iMaze,PythGC* graphs)
{
     gint i,j;
     for (i=0;i<GAME_SIZE_TILE_X;i++)
     {
	  for (j=0;j<GAME_SIZE_TILE_Y;j++)
          {
	       PytGraphics_draw_tile((int) iMaze->walls[i][j]+PIX_SNAKE,i,j,graphs);
	  }
     }
     // Full walls
     for (i=0;i<GAME_SIZE_TILE_X-1;i++)
     {
	    for (j=0;j<GAME_SIZE_TILE_Y-1;j++)
	    {
		 if ((iMaze->walls[i][j]!=16) && (iMaze->walls[i+1][j]!=16) && 
		     (iMaze->walls[i][j+1]!=16) && (iMaze->walls[i+1][j+1]!=16))
		 {
		      PytGraphics_draw_tile_true(BLOCK,(i+0.5)*SQUARE_SIZE,(j+0.5)*SQUARE_SIZE,graphs);                        
		 }
	    }
     }

     // Put title     
     if (iMaze->level == 1)  PytGraphics_put_title(graphs);
} 

void PytMaze_draw_pills(Maze* iMaze,PythGC* graphs)
{
     gint i,j;
     for (i=0;i<GAME_SIZE_TILE_X;i++)
     {
	  for (j=0;j<GAME_SIZE_TILE_Y;j++)
          {
               if (iMaze->pills[i][j])
	       {
		    PytGraphics_draw_tile((int) PILL,i,j,graphs);
	       }
	       
	  }
     }
} 

void PytMaze_generate_pills(Maze * maze)
{
     gint i,j;
     maze->rem_pills=0;
     g_print("generate pills");
     for (j=0;j<GAME_SIZE_TILE_X;j++)
     { 
	  for (i=0;i<GAME_SIZE_TILE_Y;i++)
	  { 
               maze->pills[i][j]=((maze->walls[i][j]==16) & ((i+j)%2==0));
	       maze->rem_pills+=maze->pills[i][j];
	  }
     }
 
}

void PytMaze_clear_pill(Maze* maze,gint x,gint y)
{
     if (maze->pills[x][y]) maze->rem_pills-=1;
     maze->pills[x][y]=0;
}
