#ifndef _PYTHOONG_PREFS_H_
#define _PYTHOONG_PREFS_H_
/*
 *  Pythoong 
 * (C) 2000 christophe cressend
 * 
 */

#include <glib.h>
#include <gdk_imlib.h>
#include "pythoong_def.h"

typedef struct
{
     gchar      * pythoon_pixmap;
     gint       dir[4];
     gint       number_orig;
     gint       speed;
     gint       level;
     gint       score_increase; 
     gint       diamond_freq;
     /* checks */
     gboolean   auto_move;
     gboolean   simple_graphics;
     gboolean   change_snake;
     gboolean   random_maze;
     gboolean   pix_changed;  /*only used with pref box */
}
Prefs;

void   PytPref_set_pixmap(Prefs* prefs,gchar* pixmapname);
void   PytPref_create_check_structs();
void   PytPref_show_box(Prefs*,gint game_state,GtkWidget* app);
void   PytPref_calc_score_increase(Prefs*); 
void   PytPref_save_prefs(Prefs*prefs);
void   PytPref_load_prefs(Prefs*prefs);
void   PytPref_copy_to(Prefs * prefs1,Prefs* prefs2);
void   PytPref_set_pixmap(Prefs* prefs,gchar * newpix);
void   PytPref_free(Prefs * prefs);
gint   Pyt_Prefs_get_next_level(Prefs* prefs);
gchar* Pyt_Prefs_get_next_pixmap();
gchar* Pyt_Prefs_get_level_file(gint level);
void   Pyt_Prefs_reinit_mazes();

#endif // _PYTHOONG_PREFS_H_
