/*
 *  Pythoong 
 * (C) 2000 christophe cressend
 *
 * Common defines 
 * 
 */

#define GAME_NAME   "Pythoong"

#define STATE_DEMO     0    // default mode
#define STATE_PLAYING  1    // a user plays
#define STATE_WAITING  2    // snake stopped in default mode

#define USER_IN  0    // has focus 
#define USER_OUT 1    // lost focus

//Tile size in pixels.
#define SQUARE_SIZE 24       

//Game size in tiles.
#define GAME_SIZE_TILE_X 35  
#define GAME_SIZE_TILE_Y 35

// Game size in pixels.
#define GAME_SIZE_X GAME_SIZE_TILE_X*SQUARE_SIZE
#define GAME_SIZE_Y GAME_SIZE_TILE_Y*SQUARE_SIZE

//Snake & lab pixmaps.
#define PIX_SNAKE   44
#define BLOCK       61   // block tile
#define BLANK       60   // blank tile
#define PILL        62   // normal pill
#define DIAMOND1    63   // diamond pill pix1
#define DIAMOND2    64   // diamond pill pix2
#define MASKS       65   // first tile of masks
#define COLLISION   69   // tile reserved for collision
#define PIX_MAXTILES  70 // last pix

#define PIX_TITLE_X 18 * SQUARE_SIZE
#define PIX_TITLE_Y 10 * SQUARE_SIZE
#define OFFSET_TITLE_X (GAME_SIZE_X - PIX_TITLE_X) /2
#define OFFSET_TITLE_Y (GAME_SIZE_Y - PIX_TITLE_Y) /2

#define KB_WIDTH        50
#define KB_HEIGHT       30

#define FIRST_LEVEL     "level01"
#define TITLE           "title_pyt.png"
#define ICON            "pythoong-icon.xpm"
#define PYT_SNA_DIR     "pythoong/snakes/"
#define PYT_MAZ_DIR     "pythoong/mazes/"
#define PYT_OTH_DIR     "pythoong/others/"

#define CHILD_SPEED     "Child speed"
#define	VERY_SLOW       "Very Slow"
#define	SLOW       	"Slow"
#define	MIDDLE       	"Middle"
#define	FAST       	"Fast"
#define	VERY_FAST       "Very Fast"
#define	NIGHTMARE       "Nightmare"
#define	CHILD_LEVEL     "Child level"
#define	VERY_EASY       "Very Easy"
#define	EASY            "Easy"
#define	HARD       	"Hard"
#define	VERY_HARD       "Very Hard"
#define NEVER           "Never"
#define ALMOST_NEVER    "Almost Never"
#define RARELY          "Rarely"
#define SOMETIMES       "Sometimes"
#define OFTEN           "Often"
#define VERY_OFTEN      "Very Often"
#define ALWAYS          "Always"
