/*
 *  Pythoong 
 * (C) 2000 christophe cressend
 *
 * 
 */

#include "pythoong_def.h"

#include "maze.h"
#include "snake.h"

//
//Variables
//

// Datas
static gint dir[4][2]=
{
	{0,-1},
	{-1,0},
	{0,1},
	{1,0}
};

static gint opposite[4]={2,3,0,1};

static gint orientation[40][5]=
{
	{0,8,0,9,4},
	{11,0,0,5,10},
	{6,13,0,12,0},
	{14,7,0,0,15},
	{0,28,0,30,29},
	{31,0,0,32,33},
	{35,34,0,36,0},
	{37,38,0,0,39},
	{37,38,0,0,39},
	{31,0,0,32,33},
	{0,28,0,30,29},
	{35,34,0,36,0},
	{31,0,0,32,33},
	{37,38,0,0,39},
	{35,34,0,36,0},
	{0,28,0,30,29},
	{37,38,0,0,39},
	{0,28,0,30,29},
	{31,0,0,32,33},
	{35,34,0,36,0},	
	{31,0,0,32,33},
	{0,28,0,30,29},
	{37,38,0,0,39},
	{35,34,0,36,0},
	{31,0,0,32,33},	
	{35,34,0,36,0},
	{37,38,0,0,39},	
	{0,28,0,30,29},
	{25,26,0,0,27},
	{0,16,0,18,17},
	{19,0,0,20,21},
	{23,22,0,24,0},
	{19,0,0,20,21},
	{0,16,0,18,17},
	{25,26,0,0,27},
	{23,22,0,24,0},
	{19,0,0,20,21},
	{23,22,0,24,0},
	{25,26,0,0,27},
	{0,16,0,18,17},

};

static gint orientation_queue[40]=
       	{40,41,42,43,40,41,42,43,43,41,40,42,41,43,42,40,43,40,41,42,
         41,40,43,42,41,42,43,40,43,40,41,42,41,40,43,42,41,42,43,40};

gint PytSnake_checkmove(Snake*snake,gint move)
{
     if ((PytMaze_is_walls(snake->maze,snake->val[0].x+dir[move][0],
		   snake->val[0].y+dir[move][1])!=0) ||
	   (snake->val[0].tile == opposite[move]))
	  return (1);
     return(0);
}


void PytSnake_init(Maze* iMaze,Snake* iSnake,gint l_snake)
{
     gint i,start;
     start = GAME_SIZE_TILE_X/2-1+l_snake/2;

     for (i=0;i<=GAME_SIZE_TILE_X*GAME_SIZE_TILE_Y;i++)
     {
	  iSnake->val[i].x=0;
	  iSnake->val[i].y=0;
	  iSnake->val[i].tile=BLANK;        
     }
     for (i=0;i<=l_snake;i++)
     {	
	  iSnake->val[i].x=start-i;
	  iSnake->val[i].y=GAME_SIZE_TILE_Y-2;
          PytMaze_clear_pill(iMaze,start-i,GAME_SIZE_TILE_Y-2);
     }
     iSnake->length=l_snake;
     iSnake->dir_move=3;
     iSnake->new_move=3;
     iSnake->maze=iMaze;
     iSnake->toqueue=0;
     PytSnake_calc(iSnake);
     PytSnake_compute_bounding_box(iSnake,0,iSnake->length);	  
}

gint PytSnake_find_one_move(Snake *snake)
{
     gint i=0,nb=0,good=-1;    
     for (i;i<4;i++)
     {
	 if (!PytSnake_checkmove(snake,i))
	 {
              nb+=1;
              good=i;
	 }
     }
     if (nb !=1) // more than one availiable move
     {
	good=-1;
     }     
     return (good);
}
void PytSnake_calc(Snake *snake)
{
     gint i,a,b;
      // Calculate head orientation
     a=snake->val[0].x-snake->val[1].x;
     b=snake->val[0].y-snake->val[1].y;

     if (a==1) {snake->val[0].tile=3;}	
     if (a==-1)  {snake->val[0].tile=1;}	
     if (b==1) {snake->val[0].tile=2;}
     if (b==-1)  {snake->val[0].tile=0;}

     // Calculate body.
     for (i=1;i<snake->length-1;i++)
     {
	  a=snake->val[i+1].x-snake->val[i].x;
	  b=snake->val[i+1].y-snake->val[i].y;
	  snake->val[i].tile=orientation[snake->val[i-1].tile][a+2*b+2]; // abracadabra !
     }
     // calculate queue.
     snake->val[snake->length-1].tile=orientation_queue[snake->val[snake->length-2].tile];
     snake->val[snake->length].tile=BLANK;	
     snake->isdirty=0;
}

void PytSnake_draw_init(gboolean simple,Snake* snake,PythGC* graphs)
{ 
     gint i;
     if(snake->isdirty) 
     {   
	  PytSnake_calc(snake);
	  PytSnake_compute_bounding_box(snake,0,snake->length);	  
     }
     if (simple)
     {
	  for (i=snake->length;i>=0;i--)
	  { 
               if (snake->val[i].tile != BLANK)
		    PytGraphics_draw_tile(((snake->val[i].tile-16)%12)+16,snake->val[i].x,snake->val[i].y,graphs);
	       else
		    PytGraphics_draw_tile(BLANK,snake->val[i].x,snake->val[i].y,graphs);
	  }
     }
     else
     {
	  for (i=snake->length;i>=0;i--)
	  { 
	       PytGraphics_draw_tile(snake->val[i].tile,snake->val[i].x,snake->val[i].y,graphs);
	  }
     }
//  for (i=0;i<20;i++)
//  {
//		PytGraphics_draw_tile(i,i+1,1,graphs);
//		PytGraphics_draw_tile(orientation_queue[i],i+1,2,graphs);
//  }
//  for (i=0;i<20;i++)
//  {
//		PytGraphics_draw_tile(i+20,i+1,4,graphs);
//		PytGraphics_draw_tile(orientation_queue[i+20],i+1,5,graphs);
//  }
}
void PytSnake_draw(Snake* snake,PythGC* graphs,gboolean simple)
{ 
     gint i;
     if (snake->isdirty)
     {
	  PytSnake_calc(snake);
	  if (simple)
	  {
	       PytGraphics_draw_tile(snake->val[0].tile,snake->val[0].x,snake->val[0].y,graphs);
	       PytGraphics_draw_tile(snake->val[1].tile,snake->val[1].x,snake->val[1].y,graphs);
          
	       PytGraphics_draw_tile(((snake->val[2].tile-16)%12)+16,snake->val[2].x,snake->val[2].y,graphs);
	       PytGraphics_draw_tile(snake->val[snake->length-1].tile,
				     snake->val[snake->length-1].x,snake->val[snake->length-1].y,graphs);
	       PytGraphics_draw_tile(snake->val[snake->length].tile,
				     snake->val[snake->length].x,snake->val[snake->length].y,graphs);		
	       PytSnake_compute_bounding_box(snake,0,2);	  
	       PytGraphics_send_local_buf(graphs,snake->box.x,snake->box.y,snake->box.width,snake->box.height);
	       PytSnake_compute_bounding_box(snake,snake->length-1,snake->length);	  
	       PytGraphics_send_local_buf(graphs,snake->box.x,snake->box.y,snake->box.width,snake->box.height);	  
	  }
	  else
	  { 
	       for (i=snake->length;i>=0;i--)
	       { 
		    PytGraphics_draw_tile(snake->val[i].tile,snake->val[i].x,snake->val[i].y,graphs);
	       }
	       PytSnake_compute_bounding_box(snake,0,snake->length);	  
	       PytGraphics_send_local_buf(graphs,snake->box.x,snake->box.y,snake->box.width,snake->box.height);
          }  
     }     
}

gint PytSnake_move(Snake *snake,gint dir_player)
{
     gint i;
     gint choosen=-1;
     snake->stopped=TRUE;

     if (dir_player ==-1) dir_player=snake->dir_move;
     
     dir_player=dir_player%4;
     if (!PytSnake_checkmove(snake,dir_player))
     {
          choosen=dir_player;
          snake->dir_move=choosen;
     }
     else if (!PytSnake_checkmove(snake,snake->dir_move))     
     {
	  choosen=snake->dir_move;
     }
     if (choosen != -1)
     {
	  gint i,j,k;
	  snake->stopped=FALSE;
	  if (snake->grow == TRUE)	
	  { 
	       snake->length++;
	       snake->val[snake->length].x=snake->val[snake->length-1].x;	
	       snake->val[snake->length].y=snake->val[snake->length-1].y;	   
               snake->grow=FALSE;
	  }
	  for (i=snake->length-1;i>=0;i--)
	  { 
	       snake->val[i+1].x=snake->val[i].x;	
	       snake->val[i+1].y=snake->val[i].y;
	  }           
	  snake->val[0].x=snake->val[0].x+dir[choosen][0];
	  snake->val[0].y=snake->val[0].y+dir[choosen][1];
          snake->isdirty=1;
     }
     return(choosen);
}
//
// 

gint PytSnake_cannibalism(Snake* snake)
{
     gint i;
     gint retour=0;

     for (i=4;i<=snake->length;i++) 
     { if ((snake->val[0].x==snake->val[i].x) && (snake->val[0].y==snake->val[i].y))
	  retour=1;
     }
     return(retour);
}
  
void PytSnake_destroy(Snake* snake,PythGC* graphs)
{
     gint i,collision_index=0,collision_tile=COLLISION;
     gulong micro=0;          
     gint wai=5000+600000/snake->length;
     GTimer* tim = g_timer_new();

     for (i=snake->length;i>=3;i=i-1)
     {
	  if ((snake->val[i].x == snake->val[0].x) &&  (snake->val[i].y == snake->val[0].y))   collision_index=i;
     }
     // Calculate good pixmap
     PytGraphics_calc_collision(snake->val[0].tile,snake->val[collision_index].tile,graphs);
     for (i=snake->length;i>=3;i=i-1)
     {
	  g_timer_reset(tim);
	  g_timer_start(tim);

	  PytGraphics_draw_tile(BLANK,snake->val[i].x,snake->val[i].y,graphs);
	  PytGraphics_draw_tile(orientation_queue[snake->val[i-2].tile],snake->val[i-1].x,snake->val[i-1].y,graphs);
	  PytGraphics_draw_tile(collision_tile,snake->val[0].x,snake->val[0].y,graphs);
	  PytSnake_compute_bounding_box(snake,i-1,i);
	  PytGraphics_send_local_buf(graphs,snake->box.x,snake->box.y,snake->box.width,snake->box.height);
	  PytSnake_compute_bounding_box(snake,0,0);
	  PytGraphics_send_local_buf(graphs,snake->box.x,snake->box.y,snake->box.width,snake->box.height);
	  PytGraphics_flush();
	  while (micro <wai)
	  {
	       g_timer_elapsed(tim,&micro);
	  }
	  g_timer_stop(tim);
	  micro=0;
	  if (i<=collision_index) collision_tile=snake->val[0].tile;
     }
     PytGraphics_draw_tile(BLANK,snake->val[0].x,snake->val[0].y,graphs);
     PytGraphics_draw_tile(BLANK,snake->val[1].x,snake->val[1].y,graphs);
     PytGraphics_draw_tile(BLANK,snake->val[2].x,snake->val[2].y,graphs);
     PytSnake_compute_bounding_box(snake,0,2);
     PytGraphics_send_local_buf(graphs,snake->box.x,snake->box.y,snake->box.width,snake->box.height);
     PytGraphics_flush();
}
void PytSnake_shorten(Snake* snake,PythGC* graphs)
{
     gint i;
     gulong micro=0;
     gint wai=5000+600000/snake->length;
     GTimer* tim = g_timer_new();
     gint newlength=rand()%(snake->length/2);
     if (newlength < 3) newlength=3;
     for (i=snake->length;i>=newlength;i=i-1)
     {
	      g_timer_reset(tim);
	      g_timer_start(tim);

	      PytGraphics_draw_tile(BLANK,snake->val[i].x,snake->val[i].y,graphs);
	      PytGraphics_draw_tile(orientation_queue[snake->val[i-2].tile],snake->val[i-1].x,snake->val[i-1].y,graphs);
	      PytSnake_compute_bounding_box(snake,i-1,i);
	      PytGraphics_send_local_buf(graphs,snake->box.x,snake->box.y,snake->box.width,snake->box.height);
	      PytGraphics_flush();
	      while (micro <wai)
	      {
		   g_timer_elapsed(tim,&micro);
	      }
	      g_timer_stop(tim);
	      micro=0;
     }
     snake->length=newlength;
}

void PytSnake_compute_bounding_box(Snake* snake,gint iMin,gint iMax)
{
     gint i;
     gint xmax=0,ymax=0;
     Box *b=&snake->box;
     b->x=GAME_SIZE_TILE_X;
     b->y=GAME_SIZE_TILE_Y;

     for ( i=iMin;i<=iMax;i++)
     { 
	  if (snake->val[i].x < b->x ) b->x=snake->val[i].x;
	  if (snake->val[i].x > xmax ) xmax=snake->val[i].x;
	  if (snake->val[i].y < b->y ) b->y=snake->val[i].y;
	  if (snake->val[i].y > ymax ) ymax=snake->val[i].y;
     }
     // Transfer TILE(xmin,ymin,xmax,ymax) in REAL(x,y,width,height).
     b->width=(xmax - b->x+1)*SQUARE_SIZE;
     b->height=(ymax- b->y+1)*SQUARE_SIZE;
     b->x=b->x*SQUARE_SIZE;
     b->y=b->y*SQUARE_SIZE;
}
