#ifndef _PYTHOONG_SNAKE_H_
#define _PYTHOONG_SNAKE_H_
/*
 *  Pythoong 
 * (C) 2000 christophe cressend
 *
 * 
 */

#include <glib.h>
#include "graphics.h"
#include "pythoong_def.h"
#include "maze.h"

typedef struct 
{
     gint x,y;
     gint tile;
}
coords[GAME_SIZE_TILE_X*GAME_SIZE_TILE_Y];

typedef struct 
{
     gint x,y,width,height;
}
Box;


typedef struct
{
     coords val;
     gint   length; 
     gint   dir_move;
     gint   new_move;
     gboolean stopped;
     gint   toqueue;
     gboolean grow;
     gint pills_since_diamond;
     gint   isdirty;
     Box    box;       // bounding box 
     Maze * maze;
}
Snake;

void PytSnake_init(Maze*,Snake*,gint);
void PytSnake_calc(Snake*);
void PytSnake_draw_init(gboolean simple,Snake* snake,PythGC* graphs);
void PytSnake_draw(Snake*,PythGC* graphs,gboolean simple);
gint PytSnake_checkmove(Snake*snake,gint move);
gint PytSnake_find_one_move(Snake *snake);
gint PytSnake_move(Snake*,gint);
gint PytSnake_cannibalism(Snake* snake);
void PytSnake_destroy(Snake* snake,PythGC* graphs);
void PytSnake_shorten(Snake* snake,PythGC* graphs);
void PytSnake_compute_bounding_box(Snake* snake,gint iMin,gint iMax);

#endif // _PYTHOONG_SNAKE_H_
