/*
 *  Pythoong 
 * (C) 2000 christophe cressend
 *
 * 
 */

#include <config.h>
#include <gnome.h>

#include "statusbar.h"

static GtkWidget *statusbar        = NULL;
static GtkWidget *sbtbl            = NULL;
static GtkWidget *score_area       = NULL;
static GtkWidget *score_label      = NULL;
static GtkWidget *level_label      = NULL;
static GtkWidget *pills_label      = NULL;
static GtkWidget *remaining_label  = NULL;

GtkWidget* pythoong_statusbar_new()
{
  GtkWidget *label;
  if(statusbar != NULL){
    return statusbar;
  }
  sbtbl = gtk_table_new(1, 11, FALSE);
  label = gtk_label_new(_("Score:"));
  gtk_table_attach(GTK_TABLE(sbtbl), label, 0, 1, 0, 1, 0, 0, 3, 3);
  gtk_widget_show(label);

  score_label = gtk_label_new("0");
  gtk_table_attach(GTK_TABLE(sbtbl), score_label, 1, 2, 0, 1, 0, 0, 3, 3);
  gtk_widget_show(score_label);

  gtk_table_set_col_spacing(GTK_TABLE(sbtbl), 2, 32);

  label = gtk_label_new(_("Level:"));
  gtk_table_attach(GTK_TABLE(sbtbl), label, 3, 4, 0, 1, 0, 0, 3, 3);
  gtk_widget_show(label);

  level_label = gtk_label_new("0");
  gtk_table_attach(GTK_TABLE(sbtbl), level_label, 4, 5, 0, 1, 0, 0, 3, 3);
  gtk_widget_show(level_label);   

  gtk_table_set_col_spacing(GTK_TABLE(sbtbl), 5, 32);

  label = gtk_label_new(_("Pills:"));
  gtk_table_attach(GTK_TABLE(sbtbl), label, 6, 7, 0, 1, 0, 0, 3, 3);
  gtk_widget_show(label);

  pills_label = gtk_label_new("0");
  gtk_table_attach(GTK_TABLE(sbtbl), pills_label, 7, 8, 0, 1, 0, 0, 3, 3);
  gtk_widget_show(pills_label);   

  gtk_table_set_col_spacing(GTK_TABLE(sbtbl), 8, 32);

  label = gtk_label_new(_("Snakes:"));
  gtk_table_attach(GTK_TABLE(sbtbl), label, 9, 10, 0, 1, 0, 0, 3, 3);
  gtk_widget_show(label);

  remaining_label = gtk_label_new("0");
  gtk_table_attach(GTK_TABLE(sbtbl), remaining_label, 10, 11, 0, 1, 0, 0, 3, 3);
  gtk_widget_show(remaining_label);

  gtk_widget_show(sbtbl);

  statusbar = gnome_appbar_new(FALSE, TRUE, GNOME_PREFERENCES_USER);
  gtk_box_pack_start(GTK_BOX(statusbar), sbtbl, FALSE, FALSE, 0);
  pythoong_statusbar_set(0,0,0,0);
  return statusbar;
}
gboolean pythoong_statusbar_delete()
{
  if(statusbar == NULL) return FALSE;
  gtk_widget_unref(statusbar);
  statusbar = FALSE;
  return TRUE;
}

gboolean pythoong_statusbar_set_score(gint score)
{
  gchar buffer[32];
  if(statusbar == NULL) return FALSE;
  sprintf(buffer, "%d", score);
  gtk_label_set(GTK_LABEL(score_label), buffer);
}
gboolean pythoong_statusbar_set_level(gint level)
{
  gchar buffer[32];
  if(statusbar == NULL) return FALSE;
  sprintf(buffer, "%d", level);
  gtk_label_set(GTK_LABEL(level_label), buffer);
}

gboolean pythoong_statusbar_set_pills(gint pills)
{
  gchar buffer[32];
  if(statusbar == NULL) return FALSE;
  sprintf(buffer, "%d", pills);
  gtk_label_set(GTK_LABEL(pills_label), buffer);
}

gboolean pythoong_statusbar_set_remaining(gint rem1)
{
  gchar buffer[32];
  if(statusbar == NULL) return FALSE;
  sprintf(buffer, "%d", rem1);
  gtk_label_set(GTK_LABEL(remaining_label), buffer);
}

gboolean pythoong_statusbar_set(gint score,
                                     gint level,
				     gint pills,
                                     gint rem1)
{
  if(statusbar == NULL) return FALSE;
  pythoong_statusbar_set_score(score);
  pythoong_statusbar_set_level(level);
  pythoong_statusbar_set_pills(pills);
  pythoong_statusbar_set_remaining(rem1);
  return TRUE;
}

